:root {
	/* color-scheme: light dark; */
}

body {
	font-family: Helvetica, Arial, sans-serif;
	font-size: 14px;
	margin: 0;
	/* overflow: hidden; */
}

hr {
	border: 0;
	border-top: 1px solid #ccc;
}

button {
	position: relative;
}

	input[type="color"]::-webkit-color-swatch-wrapper {
		padding: 0;
	}
	input[type="color"]::-webkit-color-swatch {
		border: none;
	}

textarea {
	tab-size: 4;
	white-space: pre;
	word-wrap: normal;
	font-family: Helvetica, Arial, sans-serif;
}

textarea.success {
	border-color: #8b8 !important;
}

textarea.fail {
	border-color: #f00 !important;
	background-color: rgba(255,0,0,0.05);
}

textarea, input {
	outline: none; /* osx */
	border: 1px solid transparent;
	color: #444;
	vertical-align: middle;
	background-color: #fafafa !important;
}

.Panel {
	-moz-user-select: none;
	-webkit-user-select: none;
	-ms-user-select: none;

	/* No support for these yet */
	-o-user-select: none;
	user-select: none;
}

.TabbedPanel {
	-moz-user-select: none;
	-webkit-user-select: none;
	-ms-user-select: none;

	/* No support for these yet */
	-o-user-select: none;
	user-select: none;
	position: relative;
	display: block;
	width: 100%;
}

.TabbedPanel .Tabs {
	position: relative;
	display: block;
	width: 100%;
	min-width: 400px;
}

	.TabbedPanel .Tabs .Tab {
		padding: 10px;
	}

	.TabbedPanel .Panels {
		position: relative;
		display: block;
		width: 100%;
		height: 100%;
		min-width: 300px;
	}

/* Listbox */
.Listbox {
	color: #444;
	background-color: #fff;
	padding: 0;
	width: 100%;
	min-height: 140px;
	font-size: 12px;
	cursor: default;
	overflow: auto;
}

.Listbox .ListboxItem {
	padding: 6px;
	color: #666;
	white-space: nowrap;
}

.Listbox .ListboxItem.active {
	background-color: rgba(0, 0, 0, 0.04);
}

/* CodeMirror */

.CodeMirror {

	position: absolute !important;
	top: 37px;
	width: 100% !important;
	height: calc(100% - 37px) !important;

}

	.CodeMirror .errorLine {

		background: rgba(255,0,0,0.25);

	}

	.CodeMirror .esprima-error {

		color: #f00;
		text-align: right;
		padding: 0 20px;

	}

/* outliner */

#outliner .opener {
	display: inline-block;
	width: 14px;
	height: 14px;
	margin: 0px 4px;
	vertical-align: top;
	text-align: center;
}

	#outliner .opener.open:after {
		content: '−';
	}

	#outliner .opener.closed:after {
		content: '+';
	}

#outliner .option {

	border: 1px solid transparent;

}

#outliner .option.drag {

	border: 1px dashed #999;

}

#outliner .option.dragTop {

	border-top: 1px dashed #999;

}

#outliner .option.dragBottom {

	border-bottom: 1px dashed #999;

}

#outliner .type {
	display: inline-block;
	width: 14px;
	height: 14px;
	color: #ddd;
	text-align: center;
}

#outliner .type:after {
	content: '●';
}

/* */

#outliner .Scene {
	color: #8888dd;
}

#outliner .Camera {
	color: #dd8888;
}

#outliner .Light {
	color: #dddd88;
}

/* */

#outliner .Object3D {
	color: #aaaaee;
}

#outliner .Mesh {
	color: #8888ee;
}

#outliner .Line {
	color: #88ee88;
}

#outliner .LineSegments {
	color: #88ee88;
}

#outliner .Points {
	color: #ee8888;
}

/* */

#outliner .Geometry {
	color: #aaeeaa;
}

#outliner .Material {
	color: #eeaaee;
}

/* */

#outliner .Script:after {
	content: '◎'
}

/*  */

button {
	color: #555;
	background-color: #ddd;
	border: 0px;
	margin: 0px; /* GNOME Web */
	padding: 5px 8px;
	font-size: 12px;
	text-transform: uppercase;
	cursor: pointer;
	outline: none;
}

	button:hover {
		background-color: #fff;
	}

	button.selected {
		background-color: #fff;
	}

input.Number {
	font-size: 12px;
	border: 0px;
	padding: 2px;
}

select {
	color: #666;
	background-color: #ddd;
	border: 0px;
	text-transform: uppercase;
	cursor: pointer;
	outline: none;
}

	select:hover {
		background-color: #fff;
	}

/* UI */

#resizer {
	position: absolute;
	top: 32px;
	right: 295px;
	width: 5px;
	bottom: 0px;
	/* background-color: rgba(255,0,0,0.5); */
	cursor: col-resize;
}

#viewport {
	position: absolute;
	top: 32px;
	left: 0;
	right: 500px;
	bottom: 0;
}

	#viewport #info {
		text-shadow: 1px 1px 0 rgba(0,0,0,0.25);
		pointer-events: none;
	}

#script {
	position: absolute;
	top: 32px;
	left: 0;
	right: 300px;
	bottom: 0;
	opacity: 0.9;
}

#player {
	position: absolute;
	top: 32px;
	left: 0;
	right: 300px;
	bottom: 0;
}

#menubar {
	position: absolute;
	width: 100%;
	height: 32px;
	background: #eee;
	padding: 0;
	margin: 0;
	right: 0;
	top: 0;
}

	#menubar .menu {
		float: left;
		cursor: pointer;
		padding-right: 8px;
	}

	#menubar .menu.right {
		float: right;
		cursor: auto;
		padding-right: 0;
		text-align: right;
	}

		#menubar .menu .title {
			display: inline-block;
			color: #888;
			margin: 0;
			padding: 8px;
			line-height: 16px;
		}

		#menubar .menu .options {
			position: fixed;
			display: none;
			padding: 5px 0;
			background: #eee;
			width: 150px;
			max-height: calc(100% - 80px);
			overflow: auto;
		}

		#menubar .menu:hover .options {
			display: block;
		}

			#menubar .menu .options hr {
				border-color: #ddd;
			}

			#menubar .menu .options .option {
				color: #666;
				background-color: transparent;
				padding: 5px 10px;
				margin: 0 !important;
			}

				#menubar .menu .options .option:hover {
					color: #fff;
					background-color: #08f;
				}

				#menubar .menu .options .option:active {
					color: #666;
					background: transparent;
				}

		#menubar .menu .options .inactive {
			color: #bbb;
			background-color: transparent;
			padding: 5px 10px;
			margin: 0 !important;
		}

#sidebar {
	position: absolute;
	right: 0;
	top: 32px;
	bottom: 0;
	width: 500px;
	background: #eee;
	overflow: auto;
}

	#sidebar .Panel {
		color: #888;
		padding: 10px;
		border-top: 1px solid #ccc;
	}

	#sidebar .Panel.collapsed {
		margin-bottom: 0;
	}

	#sidebar .Row {
		display: flex;
		align-items: center;
		min-height: 24px;
		margin-bottom: 10px;
	}

	#sidebar .Panels {
		height: unset;
	}

#commands {
	bottom: 0px;
	right: 0px;
}

	#commands .Row {
		min-height: unset;
		margin-bottom: 0px;
	}

	#commands button {
		margin: 0px 10px;
	}

#tabs {
	background-color: #ddd;
	border-top: 1px solid #ccc;
}

	#tabs span {
		color: #aaa;
		border-right: 1px solid #ccc;
		padding: 10px;
	}

	#tabs span.selected {
		color: #888;
		background-color: #eee;
	}

#toolbar {
	position: absolute;
	left: 10px;
	top: 42px;
	width: 32px;
	background: #eee;
	text-align: center;
}

	#toolbar button, #toolbar input {
		height: 32px;
	}

		#toolbar button img {
			width: 16px;
			opacity: 0.5;
		}

.Outliner {
	color: #444;
	background-color: #fff;
	padding: 0;
	width: 100%;
	height: 60px;
	font-size: 12px;
	cursor: default;
	overflow: auto;
	resize: vertical;
	outline: none !important;
}

	.Outliner .option {
		padding: 4px;
		color: #666;
		white-space: nowrap;
	}

	.Outliner .option:hover {
		background-color: rgba(0,0,0,0.02);
	}

	.Outliner .option.active {
		background-color: rgba(0,0,0,0.04);
	}


.TabbedPanel .Tabs {
	background-color: #ddd;
	border-top: 1px solid #ccc;
}

	.TabbedPanel .Tab {
		color: #aaa;
		border-right: 1px solid #ccc;
	}

	.TabbedPanel .Tab.selected {
		color: #888;
		background-color: #eee;
	}

.Listbox {
	color: #444;
	background-color: #fff;
}

.Panel {
	color: #888;
}

#results {
	background-color: #fff;
	margin: 0px 10px;
}

#results__loading {
	padding: 20px;
}

#results__loading span:first-of-type {
	font-weight: bold;
	text-align: center;
	width: 100%;
  margin-bottom: 10px;
}

/* */

@media all and ( max-width: 600px ) {

	#resizer {
		display: none;
	}

	#menubar .menu .options {
		max-height: calc(100% - 372px);
	}

	#menubar .menu.right {
		display: none;
	}

	#viewport {
		left: 0;
		right: 0;
		top: 32px;
		height: calc(100% - 352px);
	}

	#script {
		left: 0;
		right: 0;
		top: 32px;
		height: calc(100% - 352px);
	}

	#player {
		left: 0;
		right: 0;
		top: 32px;
		height: calc(100% - 352px);
	}

	#sidebar {
		left: 0;
		width: 100%;
		top: calc(100% - 320px);
		bottom: 0;
	}

}

/* Custom */
.Button {
	cursor: pointer;
}

.Button--disabled {
	cursor:not-allowed;
	color: #bababa;
  background-color: #fff;
}

.Button--disabled:hover {
	color: #bababa;
  background-color: #fff;
}

/* Home page */

#root {
	padding: 20px;
	font-size: 16px;
}

#root button {
	margin: 0px 4px;
}

.home-box {
	margin: 20px 0px;
	padding: 10px;
	border: 1px solid #aaa;
	background-color: #eeee;
}

#new {
	margin: 20px 0px;
}

#new button {
	border: 1px solid #444;
}

.model span {
	margin-right: 20px;
}

.model button {
	border: 1px solid #aaa;
}

.model__name {
	margin-bottom: 20px;
	font-weight: bold;
}

.container {
	display: flex;
	justify-content: space-between;
}

.container > div {
	max-width: 48%;
}

#machine input {
	margin: 4px 40px 4px 6px;
	font-size: 14px;
	color: black !important;
}


.parameters {
	margin-bottom: 5px;
}

.parameters input {
	vertical-align: baseline;
	margin: 0px 6px;
}

#estimation span:nth-of-type(2) {
	margin: 0px 6px;
}

#cumulative-alert {
	color: #f55;
	font-weight: bold;
	display: none;
}

#footer {
	border: 1px solid #aaa;
	margin-top: 40px;
	padding: 10px;
}

.tooltip {	
	background-color: #444;
	color: #fafafa;
	border: 1px solid #fafafa;
	border-radius: 8px;
	box-shadow: 0px 0px 1px 1px #444;
	position: absolute;
	padding: 4px 8px;
	font-size: 12px;
	opacity: 0%;
	left: 0px;
	bottom: 0px;	
	width: max-content;
	max-width: 150px;
	text-transform: none;
	transform: translateY(calc(100% + 8px));
	z-index: 10;
	text-align: left;
	pointer-events: none;
}

*:hover > .tooltip {	
	opacity: 100%;
	transition: opacity 2s cubic-bezier(1, -0.25, 1, -0.25);
}